#!/usr/bin/env perl
# $Id: kuttuki-rss.pl,v 1.1.1.1 2003/09/07 03:07:00 yto Exp $
# äĤ RSS
#
# This is free software with ABSOLUTELY NO WARRANTY.
# ̵̵ݾڡ (see http://nais.to/~yto/doc/zb/0002.html)
#
# usage: prog [options] url
#   options: 
#     -n NUM   ɽ (ǥեȤ)
#     -e euc|jis|sjis|utf8   ܸ쥳
#     -o FILENAME   ϥե̾
#
# : kuttuki-rss.pl http://example.com/~yto/hehehe.rdf -o rss.js
#
# Web ڡؤΤäĤ (): 
# <div class="rssbox">
# <script language="JavaScript" src="rss.js"></script>
# </div>

use strict;
use Jcode;
use XML::RSS;
use CGI;
use LWP::Simple;
use Getopt::Long;

$Getopt::Long::autoabbrev = 1;
my %opt = ();
GetOptions(\%opt, "number=s", "encode=s", "output=s");
my $number = $opt{'number'} || -1;
my $encode = $opt{'encode'} || "euc";
my $output_fn = $opt{'output'} || "rss.js";

my $rss_url = shift;

my $rss_cont;

if ($rss_url =~ /^\s*http/) {
    ($rss_cont = get($rss_url)) or die "Can't get $rss_url\n";
} else {
    open(F, $rss_url) or die "Can't open $rss_url : $!\n";
    $rss_cont = join('', <F>);
    close(F);
}

if ($rss_cont =~ s/encoding="([^u].+)"/encoding="utf-8"/i) {
    $rss_cont = Jcode->new($rss_cont)->utf8;
}

my $day_mode = ($rss_cont =~ /<title>\d{4}\D\d\d\D\d\d/) ? 1 : 0;

my $rss = XML::RSS->new;
$rss->parse($rss_cont);

my $clink = $rss->channel('link');
my $ctitle = $rss->channel('title');
my $str = qq(<table><tr><td><a href="$clink">$ctitle</a></td></tr><tr><td>);

if ($day_mode) {		# for diary type rss file
    my %items_hash;
    foreach (@{$rss->items}) {
	my ($date, $ititle) = ($_->{title} =~ /^(\d+\D\d+\D\d+).*?\s+(.+)$/);
	push @{$items_hash{$date}}, [$ititle, $_->{link}]; 
	last if ($number > 0 and --$number == 0);
    }
    $str .= "<dl>";
    foreach my $d (sort {$b cmp $a} keys %items_hash) {
	$str .= qq(<dt><a>$d</a><dd><ul>);
	foreach my $i (@{$items_hash{$d}}) {
	    $str .= qq(<li><a href="$i->[1]">$i->[0]</a>);
	}
	$str .= "</ul>";
    }
    $str .= "</dl>";
} else {			# for general rss file
    $str .= "<ul>";
    foreach (@{$rss->items}) {
	$str .= qq(<li><a href="$_->{link}">$_->{title}</a>);
	last if ($number > 0 and --$number == 0);
    }
    $str .= "</ul>";
}

$str .= "</td></tr></table>";

Jcode::convert(\$str, $encode, "utf8");

open(F, "> $output_fn") or die "Can't open $output_fn : $!\n";
print F "document.writeln('$str');\n";
close(F);
